/* Zadatak 2C:

*/

#include <stdio.h>
#include <stdlib.h>

    /* Globalna deklaracija tipa za element liste. */

typedef struct _voz {
    char prezime[40];
    char ime[40];
    int broj;
    char ekipa[3];
    double rezultat[18];
    struct _voz* next;
} voz;

    /* Funkcija izbaci iz (a). */

voz* izbaci(voz* first, int n, voz** spori)
{
    voz *first_izb = NULL, *preth, *pom, *izbacen;

        /* Maksimalno vrijeme i vrijeme "reza" za izbacivanje. */
    double max_vr, rez;

        /* Test na praznu listu i izlazne vrijednosti. */
    if (first == NULL) {
        *spori = NULL;
        return NULL;
    }

        /* Prvi prolaz po listi za nalazenje reza. */
    max_vr = first->rezultat[n];
    for (pom = first->next; pom != NULL; pom = pom->next) {
        if (pom->rezultat[n] > max_vr)
            max_vr = pom->rezultat[n];
    }
        /* Rez = 90% najveceg vremena, tj. faktor = 0.9. */
    rez = 0.9 * max_vr;

        /* Drugi prolaz po listi za izbacivanje sporih. */
    pom = first;
    preth = NULL;    /* Nije nuzno. */

    while (pom != NULL) {

            /* Provjera rezultata u n-toj utrci. */
        if (pom->rezultat[n] > rez) {

                /* Pokazivac na element kojeg treba izbaciti. */
            izbacen = pom;

                /* Izbaci ga iz zadane liste, postavi novi pom.
                   Preth se NE mijenja, zbog izbacivanja. */
            if (pom == first) {    /* <=> preth == NULL. */
                first = first->next;
                pom = first;
            }
            else {    /* <=> pom == preth->next. */
                preth->next = pom->next;
                pom = preth->next;
            }

                /* Ubaci izbacenog na pocetak liste izbacenih
                   (jer poredak izbacenih nije bitan). */
            izbacen->next = first_izb;
            first_izb = izbacen;
        }
        else {    /* Nema izbacivanja, makni preth i pom. */
            preth = pom;
            pom = preth->next;
        }
    }

        /* Vrati pocetak liste izbacenih kroz varijabilni argument. */
    *spori = first_izb;

        /* Vrati pokazivac na prvi element preostale liste. */
    return first;
}

    /* Funkcija merge za (uzlazno) sortirano spajanje dvije liste.
       Treba za poredaj = mergesort u (b).
       Dodatni ulazni argument je indeks utrke n,
       jer se sortira po rezultatu u n-toj utrci. */

voz* merge(voz* first_1, voz* first_2, int n)
{
    voz *first = NULL, *last, *pom;

    if (first_1 == NULL) return first_2;
    if (first_2 == NULL) return first_1;

        /* Prolaz po obje liste, sve dok su obje neprazne. */
    while (first_1 != NULL && first_2 != NULL) {

            /* Izbaci manjeg s pocetka njegove liste. */
        if (first_1->rezultat[n] <= first_2->rezultat[n]) {
            pom = first_1;
            first_1 = first_1->next;
        }
        else {
            pom = first_2;
            first_2 = first_2->next;
        }

            /* Ubaci ga na kraj sortirane liste. */
        if (first == NULL)
            first = pom;
        else
            last->next = pom;
        last = pom;
    }

        /* Spoji neprazni ostatak na kraj sortirane liste. */
    if (first_1 == NULL)
        last->next = first_2;
    if (first_2 == NULL)
        last->next = first_1;

    return first;
}

    /* Funkcija poredaj iz (b).
       Rekurzivno sortira listu mergesort algoritmom.
       Raspolavljanje preko pokazivaca, bez broja elemenata! */

voz* poredaj(voz* first, int n)
{
    voz *last, *first_2;

        /* Test na praznu ili jednoclanu listu. */
    if ((first == NULL) || (first->next == NULL))
        return first;

        /* Raspolovi listu. Pokazivac last pokazuje na zadnjeg
           u prvom dijelu. Pokazivac first_2 je trenutno pomocni
           i sluzi za raspolavljanje liste. */
    last = first;
    first_2 = first->next;

        /* Pomicemo last za JEDNO mjesto, a first_2 za DVA mjesta,
           sve dok first_2 ne stigne do kraja liste. */
    while ((first_2 != NULL) && (first_2->next != NULL)) {
        last = last->next;
        first_2 = first_2->next->next;
    }

        /* Pokazivac last sad korektno pokazuje na zadnjeg u prvom
           dijelu. Pokazivac first_2 postavljamo na prvog u drugom
           dijelu (prvi iza last) i korektno zavrsavamo prvi dio. */
    first_2 = last->next;
    last->next = NULL;

        /* Rekurzivno sortiranje obje liste i sortirano spajanje. */
    first = merge(poredaj(first, n), poredaj(first_2, n), n);

    return first;
}


/* ========================================================================= */

    /* Pomocni tipovi za listu (element i pokazivac na element). */

typedef voz element;
typedef element *lista;


    /* Pomocne konstante za ovu grupu zadatka. */

int broj_elemenata = 20;

int broj_utrka = 18;
char kratica[3] = { 'A', 'S', 'T' };    /* Fiksna kratica ekipe. */

int min_time = 3600;
int max_time = 5400;
int dio_sek  = 1000;    /* Tisucinke. */

    /* Brzo generiranje slucajnog broja iz [0, 2^30 - 1].
       KORISTI da je RAND_MAX = 2^15 - 1.
       Dvostruki poziv rand(), uz pomak prvog broja za 15 bitova. */

int randint(void) {
    return ( rand() << 15 ) + rand();
}

    /* Pomocna funkcija za kreiranje liste. */

lista kreiraj_listu(void)
{
    lista first = NULL, pom;
    int i, j, n, vr;
    double vrijeme;

        /* Kreira zadani broj elemenata, u obratnom poretku
           (ubacuje na pocetak liste). */

    for (i = broj_elemenata; i >= 1; --i) {

            /* Alokacija novog elementa. */
        pom = (lista) malloc(sizeof(element));
        if (pom == NULL) {
            printf("Alokacija nije uspjela.\n");
            exit(EXIT_FAILURE);
        }

            /* Generiranje podataka u novom elementu. */

            /* Ime je "Ime nn", gdje je nn = bas broj i. */
        sprintf(pom->ime, "Ime %02d", i);
            /* Prezime je "Prezime nn", gdje je nn = bas broj i. */
        sprintf(pom->prezime, "Prezime %02d", i);

            /* Natjecateljski broj je bas i (da ne kompliciramo). */
        pom->broj = i;

            /* Kratica ekipe je fiksna kratica, znak po znak
               (nije bitna za demo-podatke). */
        for (j = 0; j < 3; ++j)
            pom->ekipa[j] = kratica[j];


            /* Rezultati u svim utrkama. */
        for (n = 0; n < broj_utrka; ++n) {

                /* Slucajni int. */
            vr = randint();
                /* Skaliranje na zeljeni interval dijelova sekunde. */
            vr = min_time * dio_sek
                   + vr % ( (max_time - min_time) * dio_sek );
                /* Pretvaranje u double i sekunde. */
            vrijeme = (double) vr / dio_sek;

            pom->rezultat[n] = vrijeme;
        }

            /* Ubaci novi element na pocetak liste. */
        pom->next = first;
        first = pom;
    }

    return first;
}

    /* Pomocna funkcija za ispis liste. Ispisuje samo
       natjecateljski broj i rezultat u utrci s indeksom n. */

void ispisi_listu(lista first, int n)
{
    lista pom;
    int brojac = 0;

    for (pom = first; pom != NULL; pom = pom->next) {
        printf("   [%2d]:    broj = %3d,  vrijeme = %9.3f\n",
               ++brojac, pom->broj, pom->rezultat[n]);
    }
    printf("\n");
    return;
}

    /* Pomocna funkcija za brisanje liste. */

void obrisi_listu(lista first)
{
    lista pom;
    while (first != NULL) {
        pom = first;
        first = first->next;
        free(pom);
    }
    return;
}

/* ========================================================================= */

    /* Glavni program za demo. */

int main(void)
{
    voz *first = NULL, *spori = NULL;

        /* Kreiranje liste sa slucajnim vremenima. */
    first = kreiraj_listu();

        /* Ispis polazne liste. */
    printf(" Pocetna lista:\n");
    ispisi_listu(first, 5);


        /* Poziv funkcije izbaci iz (a). */
    first = izbaci(first, 5, &spori);

    printf("\n");
    printf(" Lista sporih (nakon izbacivanja):\n");
    ispisi_listu(spori, 5);

    printf("\n");
    printf(" Lista preostalih prije sorta:\n");
    ispisi_listu(first, 5);


        /* Poziv funkcije poredaj iz (b). */
    first = poredaj(first, 5);

    printf(" Lista preostalih nakon sorta:\n");
    ispisi_listu(first, 5);


        /* Obrisi obje liste. */
    obrisi_listu(spori);
    obrisi_listu(first);

    return 0;
}
