/* Zadatak 3B:

*/

#include <stdio.h>
#include <stdlib.h>

    /* Globalno polje bod s bodovima prema poretku,
       od prvog do 40. mjesta. */

int bod[40] = {
    60, 55, 50, 48, 46, 44, 42, 40, 38, 36,
    34, 32, 30, 28, 26, 25, 24, 23, 22, 21,
    20, 19, 18, 17, 16, 15, 14, 13, 12, 11,
    10,  9,  8,  7,  6,  5,  4,  3,  2,  1 };

int n_bod = 40;

    /* Globalna deklaracija tipa. */

typedef struct {
    char prezime[25];
    char ime[25];
    int broj;
    char drzava[3];
    int bodovi;
} bia_bod;

    /* Funkcija popis iz (a).
       Vraca pokazivac na prvi element u polju biatlonaca. */

bia_bod* popis(int n, int* p_broj)
{
    bia_bod* polje = NULL;
    char ime_dat[20];
    FILE* ulaz;
    int broj_bia = 0, i, j, natj_br, indeks, k;
    double vrijeme;

        /* Petlja za ulazne datoteke. */
    for (i = 1; i <= n; ++i) {

            /* Ime datoteke dobivamo pisanjem u string ime_dat. */
        sprintf(ime_dat, "z3b_%d.txt", i);
            /* Otvori i-tu datoteku. */
        ulaz = fopen(ime_dat, "r");

            /* Petlja za citanje prvih 40, jer samo oni osvajaju bodove.
               Moze i manje od 40, ako naidjemo na EOF. */
        for (j = 0; j < n_bod; ++j) {

                /* Citanje natjecateljskog broja i vremena,
                   s provjerom na EOF. */
            if (fscanf(ulaz, "%d %lf", &natj_br, &vrijeme) < 2) break;

                /* Probaj naci taj natjecateljski broj u polju. */
            indeks = -1;
            for (k = 0; k < broj_bia; ++k)
                if (polje[k].broj == natj_br) {
                        /* Nasli smo ga na indeksu k. */
                    indeks = k;
                        /* Povecaj mu bodove. */
                    polje[k].bodovi += bod[j];
                    break;
                }
                /* Ako ga nismo nasli, realociraj polje. */
            if (indeks == -1) {
                indeks = broj_bia;
                ++broj_bia;
                polje = (bia_bod*) realloc(polje, broj_bia * sizeof(bia_bod));
                    /* Postavi broj i bodove za novog. */
                polje[indeks].broj = natj_br;
                polje[indeks].bodovi = bod[j];
            }
        }    /* Kraj petlje po j. */

            /* Zatvori i-tu datoteku. */
        fclose(ulaz);
    }

        /* Vrati broj biatlonaca u polju kroz varijabilni argument. */
    *p_broj = broj_bia;

        /* Vrati pokazivac na prvog u polju. */
    return polje;
}

    /* Funkcija za usporedbu biatlonaca - treba za (b).
       Logicki gledano, vraca tko je manji (a ne veci),
       jer zelimo silazno sortiranje u qsort. */

int usporedi(const bia_bod* p_prvi, const bia_bod* p_drugi)
{
    if (p_prvi->bodovi < p_drugi->bodovi)
        return 1;
    else if (p_prvi->bodovi > p_drugi->bodovi)
        return -1;
    else
        return 0;
}

    /* Deklaracija tipa funkcije za usporedbu za poziv qsort. */

typedef int (*Comp_fun)(const void*, const void*);

    /* Funkcija rang_lista iz (b). */

void rang_lista(bia_bod* polje, int broj_bia)
{
    qsort(polje, broj_bia, sizeof(bia_bod), (Comp_fun) usporedi);
}


    /* Pomocna funkcija za ispis polja biatlonaca. */

void ispis(bia_bod* polje, int broj_bia)
{
    int i;
    for (i = 0; i < broj_bia; ++i)
        printf("   [%2d]:    broj = %3d,  bodovi = %3d\n",
               i + 1, polje[i].broj, polje[i].bodovi);
    printf("\n");
    return;
}

    /* Glavni program za demo. */

int main(void)
{
    bia_bod* polje;
    int broj_bia;

        /* Poziv funkcije iz (a). */
    polje = popis(3, &broj_bia);

    printf(" Polje prije sorta:\n");
    ispis(polje, broj_bia);

        /* Poziv funkcije iz (b). */
    rang_lista(polje, broj_bia);

    printf(" Rang-lista nakon sorta:\n");
    ispis(polje, broj_bia);

        /* Dealokacija polja. */
    free(polje);

    return 0;
}
