/* Zadatak 3C:

*/

#include <stdio.h>
#include <stdlib.h>

    /* Globalno polje bod s bodovima prema poretku,
       od prvog do 15. mjesta. */

int bod[15] = {
    25, 22, 20, 18, 16, 14, 12, 10,  8,  6,
     5,  4,  3,  2,  1 };

int n_bod = 15;

    /* Globalna deklaracija tipa. */

typedef struct {
    char prezime[40];
    char ime[40];
    int broj;
    char ekipa[3];
    int bodovi;
} voz_bod;

    /* Funkcija popis iz (a).
       Vraca pokazivac na prvi element u polju vozaca. */

voz_bod* popis(int n, int* p_broj)
{
    voz_bod* polje = NULL;
    char ime_dat[20];
    FILE* ulaz;
    int broj_voz = 0, i, j, natj_br, indeks, k;
    double vrijeme;

        /* Petlja za ulazne datoteke. */
    for (i = 1; i <= n; ++i) {

            /* Ime datoteke dobivamo pisanjem u string ime_dat. */
        sprintf(ime_dat, "z3c_%d.txt", i);
            /* Otvori i-tu datoteku. */
        ulaz = fopen(ime_dat, "r");

            /* Petlja za citanje prvih 15, jer samo oni osvajaju bodove.
               Moze i manje od 15, ako naidjemo na EOF. */
        for (j = 0; j < n_bod; ++j) {

                /* Citanje natjecateljskog broja i vremena,
                   s provjerom na EOF. */
            if (fscanf(ulaz, "%d %lf", &natj_br, &vrijeme) < 2) break;

                /* Probaj naci taj natjecateljski broj u polju. */
            indeks = -1;
            for (k = 0; k < broj_voz; ++k)
                if (polje[k].broj == natj_br) {
                        /* Nasli smo ga na indeksu k. */
                    indeks = k;
                        /* Povecaj mu bodove. */
                    polje[k].bodovi += bod[j];
                    break;
                }
                /* Ako ga nismo nasli, realociraj polje. */
            if (indeks == -1) {
                indeks = broj_voz;
                ++broj_voz;
                polje = (voz_bod*) realloc(polje, broj_voz * sizeof(voz_bod));
                    /* Postavi broj i bodove za novog. */
                polje[indeks].broj = natj_br;
                polje[indeks].bodovi = bod[j];
            }
        }    /* Kraj petlje po j. */

            /* Zatvori i-tu datoteku. */
        fclose(ulaz);
    }

        /* Vrati broj vozaca u polju kroz varijabilni argument. */
    *p_broj = broj_voz;

        /* Vrati pokazivac na prvog u polju. */
    return polje;
}

    /* Funkcija za usporedbu vozaca - treba za (b).
       Logicki gledano, vraca tko je manji (a ne veci),
       jer zelimo silazno sortiranje u qsort. */

int usporedi(const voz_bod* p_prvi, const voz_bod* p_drugi)
{
    if (p_prvi->bodovi < p_drugi->bodovi)
        return 1;
    else if (p_prvi->bodovi > p_drugi->bodovi)
        return -1;
    else
        return 0;
}

    /* Deklaracija tipa funkcije za usporedbu za poziv qsort. */

typedef int (*Comp_fun)(const void*, const void*);

    /* Funkcija rang_lista iz (b). */

void rang_lista(voz_bod* polje, int broj_voz)
{
    qsort(polje, broj_voz, sizeof(voz_bod), (Comp_fun) usporedi);
}


    /* Pomocna funkcija za ispis polja vozaca. */

void ispis(voz_bod* polje, int broj_voz)
{
    int i;
    for (i = 0; i < broj_voz; ++i)
        printf("   [%2d]:    broj = %3d,  bodovi = %3d\n",
               i + 1, polje[i].broj, polje[i].bodovi);
    printf("\n");
    return;
}

    /* Glavni program za demo. */

int main(void)
{
    voz_bod* polje;
    int broj_voz;

        /* Poziv funkcije iz (a). */
    polje = popis(3, &broj_voz);

    printf(" Polje prije sorta:\n");
    ispis(polje, broj_voz);

        /* Poziv funkcije iz (b). */
    rang_lista(polje, broj_voz);

    printf(" Rang-lista nakon sorta:\n");
    ispis(polje, broj_voz);

        /* Dealokacija polja. */
    free(polje);

    return 0;
}
