/* Zadatak 3D:

*/

#include <stdio.h>
#include <stdlib.h>

    /* Globalno polje bod s bodovima prema poretku,
       od prvog do 30. mjesta. */

int bod[30] = {
    50, 45, 40, 38, 36, 34, 32, 30, 28, 26,
    24, 22, 20, 18, 16, 15, 14, 13, 12, 11,
    10,  9,  8,  7,  6,  5,  4,  3,  2,  1 };

int n_bod = 30;

    /* Globalna deklaracija tipa. */

typedef struct {
    char ime[35];
    char prezime[35];
    int broj;
    char drzava[3];
    int bodovi;
} trk_bod;

    /* Funkcija popis iz (a).
       Vraca pokazivac na prvi element u polju trkaca. */

trk_bod* popis(int n, int* p_broj)
{
    trk_bod* polje = NULL;
    char ime_dat[20];
    FILE* ulaz;
    int broj_trk = 0, i, j, natj_br, indeks, k;
    double vrijeme;

        /* Petlja za ulazne datoteke. */
    for (i = 1; i <= n; ++i) {

            /* Ime datoteke dobivamo pisanjem u string ime_dat. */
        sprintf(ime_dat, "z3d_%d.txt", i);
            /* Otvori i-tu datoteku. */
        ulaz = fopen(ime_dat, "r");

            /* Petlja za citanje prvih 30, jer samo oni osvajaju bodove.
               Moze i manje od 30, ako naidjemo na EOF. */
        for (j = 0; j < n_bod; ++j) {

                /* Citanje natjecateljskog broja i vremena,
                   s provjerom na EOF. */
            if (fscanf(ulaz, "%d %lf", &natj_br, &vrijeme) < 2) break;

                /* Probaj naci taj natjecateljski broj u polju. */
            indeks = -1;
            for (k = 0; k < broj_trk; ++k)
                if (polje[k].broj == natj_br) {
                        /* Nasli smo ga na indeksu k. */
                    indeks = k;
                        /* Povecaj mu bodove. */
                    polje[k].bodovi += bod[j];
                    break;
                }
                /* Ako ga nismo nasli, realociraj polje. */
            if (indeks == -1) {
                indeks = broj_trk;
                ++broj_trk;
                polje = (trk_bod*) realloc(polje, broj_trk * sizeof(trk_bod));
                    /* Postavi broj i bodove za novog. */
                polje[indeks].broj = natj_br;
                polje[indeks].bodovi = bod[j];
            }
        }    /* Kraj petlje po j. */

            /* Zatvori i-tu datoteku. */
        fclose(ulaz);
    }

        /* Vrati broj trkaca u polju kroz varijabilni argument. */
    *p_broj = broj_trk;

        /* Vrati pokazivac na prvog u polju. */
    return polje;
}

    /* Funkcija za usporedbu trkaca - treba za (b).
       Logicki gledano, vraca tko je manji (a ne veci),
       jer zelimo silazno sortiranje u qsort. */

int usporedi(const trk_bod* p_prvi, const trk_bod* p_drugi)
{
    if (p_prvi->bodovi < p_drugi->bodovi)
        return 1;
    else if (p_prvi->bodovi > p_drugi->bodovi)
        return -1;
    else
        return 0;
}

    /* Deklaracija tipa funkcije za usporedbu za poziv qsort. */

typedef int (*Comp_fun)(const void*, const void*);

    /* Funkcija rang_lista iz (b). */

void rang_lista(trk_bod* polje, int broj_trk)
{
    qsort(polje, broj_trk, sizeof(trk_bod), (Comp_fun) usporedi);
}


    /* Pomocna funkcija za ispis polja trkaca. */

void ispis(trk_bod* polje, int broj_trk)
{
    int i;
    for (i = 0; i < broj_trk; ++i)
        printf("   [%2d]:    broj = %3d,  bodovi = %3d\n",
               i + 1, polje[i].broj, polje[i].bodovi);
    printf("\n");
    return;
}

    /* Glavni program za demo. */

int main(void)
{
    trk_bod* polje;
    int broj_trk;

        /* Poziv funkcije iz (a). */
    polje = popis(3, &broj_trk);

    printf(" Polje prije sorta:\n");
    ispis(polje, broj_trk);

        /* Poziv funkcije iz (b). */
    rang_lista(polje, broj_trk);

    printf(" Rang-lista nakon sorta:\n");
    ispis(polje, broj_trk);

        /* Dealokacija polja. */
    free(polje);

    return 0;
}
