/* Zadatak 4A:

*/

#include <stdio.h>
#include <stdlib.h>

    /* Globalna deklaracija tipa. */

typedef struct {
    char ime[30];
    char prezime[30];
    int broj;
    char ekipa[3];
    int bodovi;
} bic_bod;

    /* Funkcija za generiranje slucajnog poretka u grupi. */

void slucajno_poredaj(bic_bod* polje, int n)
{
    int i, j, nm1 = n - 1;
    bic_bod temp;

    for (i = 0; i < nm1; ++i) {
            /* Generiramo slucajni indeks u
               cjelobrojnom intervalu [i, n - 1].
               Uociti da je n - i = nm1 - i + 1. */
        j = i + rand() % (n - i);
            /* Zamijenimo elemente s indeksima i, j. */
        if (i != j) {
            temp = polje[i];
            polje[i] = polje[j];
            polje[j] = temp;
        }
    }
    return;
}

    /* Funkcija za ispis jednog biciklista u izlaznu datoteku.
       Argumenti funkcije su izlazna datoteka, startni broj i
       pokazivac na biciklista (da izbjegnemo kopiranje strukture). */

void ispis_bic(FILE* izlaz, int start, bic_bod* p_bic)
{
    int j;

        /* Startni broj i natjecateljski broj. */
    fprintf(izlaz, "%d, %d, ", start, p_bic->broj);
        /* Kratica ekipe. */
    for (j = 0; j < 3; ++j)
        fprintf(izlaz, "%c", p_bic->ekipa[j]);
/* Umjesto gornje petlje po j, cijelu kraticu mozemo ispisati
   kao string, ali tako da pisemo najvise 3 znaka iz polja:
    fprintf(izlaz, "%.3s", p_bic->ekipa);
*/
        /* Zarez, prezime, ime. */
    fprintf(izlaz, ", %s, %s\n", p_bic->prezime, p_bic->ime);

    return;
}

    /* Glavni program. */

int main(int argc, char *argv[])
{
    FILE *ulaz, *izlaz;
    bic_bod vodeci[15], grupa[15];
    int max_grupa = 15;
    int n_vodeci, n_grupa, start = 0, i;

        /* Otvaranje ulazne binarne datoteke. */
    ulaz = fopen(argv[1], "rb");

        /* Otvaranje izlazne tekstualne datoteke. */
    izlaz = fopen(argv[2], "w");

        /* Citanje vodece grupe u posebno polje vodeci, jer grupu
           vodecih obradjujemo na kraju, iza svih ostalih grupa.
           Broj ucitanih spremamo u n_vodeci. */
    n_vodeci = fread(vodeci, sizeof(bic_bod), max_grupa, ulaz);

        /* Postavi broj ucitanih u prethodnoj (= prvoj) grupi.
           Sluzi jednostavnom zapisu uvjeta petlje za obradu svih
           preostalih grupa (ne moramo posebno testirati n_vodeci). */
    n_grupa = n_vodeci;

        /* Petlja za obradu ostalih grupa.
           Sve dok je prethodna grupa bila skroz popunjena (svih 15),
           nastavljamo petlju. U protivnom, naisli smo na EOF
           kod citanja grupe => prekid petlje. */
    while (n_grupa == max_grupa) {

            /* Ucitaj sljedecu grupu.
               Broj ucitanih spremamo u n_grupa. */
        n_grupa = fread(grupa, sizeof(bic_bod), max_grupa, ulaz);

            /* Ako je grupa prazna (EOF), prekidamo petlju.
               Ovaj test NIJE potreban, jer sve ispod radi
               i za n_grupa == 0. */
        if (n_grupa == 0) break;

            /* Slucajna permutacija grupe. */
        slucajno_poredaj(grupa, n_grupa);

            /* Ispis te grupe. */
        for (i = 0; i < n_grupa; ++i)
            ispis_bic(izlaz, ++start, &grupa[i]);
    }

        /* Na samom kraju, obradimo vodecu grupu,
           tj. ispisemo ju u obrnutom redoslijedu. */
    for (i = n_vodeci - 1; i >= 0; --i)
        ispis_bic(izlaz, ++start, &vodeci[i]);

        /* Zatvaranje datoteka. */
    fclose(ulaz);
    fclose(izlaz);

    return 0;
}
