/* Zadatak 4D:

*/

#include <stdio.h>
#include <stdlib.h>

    /* Globalna deklaracija tipa. */

typedef struct {
    char ime[35];
    char prezime[35];
    int broj;
    char drzava[3];
    int bodovi;
} trk_bod;

    /* Funkcija za generiranje slucajnog poretka u grupi. */

void slucajno_poredaj(trk_bod* polje, int n)
{
    int i, j, nm1 = n - 1;
    trk_bod temp;

    for (i = 0; i < nm1; ++i) {
            /* Generiramo slucajni indeks u
               cjelobrojnom intervalu [i, n - 1].
               Uociti da je n - i = nm1 - i + 1. */
        j = i + rand() % (n - i);
            /* Zamijenimo elemente s indeksima i, j. */
        if (i != j) {
            temp = polje[i];
            polje[i] = polje[j];
            polje[j] = temp;
        }
    }
    return;
}

    /* Funkcija za ispis jednog trkaca u izlaznu datoteku.
       Argumenti funkcije su izlazna datoteka, startni broj i
       pokazivac na trkaca (da izbjegnemo kopiranje strukture). */

void ispis_trk(FILE* izlaz, int start, trk_bod* p_trk)
{
    int j;

        /* Startni broj i natjecateljski broj. */
    fprintf(izlaz, "%d, %d, ", start, p_trk->broj);
        /* Kratica drzave. */
    for (j = 0; j < 3; ++j)
        fprintf(izlaz, "%c", p_trk->drzava[j]);
/* Umjesto gornje petlje po j, cijelu kraticu mozemo ispisati
   kao string, ali tako da pisemo najvise 3 znaka iz polja:
    fprintf(izlaz, "%.3s", p_trk->drzava);
*/
        /* Zarez, prezime, ime. */
    fprintf(izlaz, ", %s, %s\n", p_trk->prezime, p_trk->ime);

    return;
}

    /* Glavni program. */

int main(int argc, char *argv[])
{
    FILE *ulaz, *izlaz;
    trk_bod grupa[25];
    int max_grupa = 25;
    int n_grupa, start = 0, i;

        /* Otvaranje ulazne binarne datoteke. */
    ulaz = fopen(argv[1], "rb");

        /* Otvaranje izlazne tekstualne datoteke. */
    izlaz = fopen(argv[2], "w");

        /* Citanje vodece grupe. Broj ucitanih spremamo u n_grupa. */
    n_grupa = fread(grupa, sizeof(trk_bod), max_grupa, ulaz);

        /* Odmah obradimo vodecu grupu,
           tj. ispisemo ju u redoslijedu prema poretku. */
    for (i = 0; i < n_grupa; ++i)
        ispis_trk(izlaz, ++start, &grupa[i]);

        /* Petlja za obradu ostalih grupa.
           Sve dok je prethodna grupa bila skroz popunjena (svih 25),
           nastavljamo petlju. U protivnom, naisli smo na EOF
           kod citanja grupe => prekid petlje. */
    while (n_grupa == max_grupa) {

            /* Ucitaj sljedecu grupu.
               Broj ucitanih spremamo u n_grupa. */
        n_grupa = fread(grupa, sizeof(trk_bod), max_grupa, ulaz);

            /* Ako je grupa prazna (EOF), prekidamo petlju.
               Ovaj test NIJE potreban, jer sve ispod radi
               i za n_grupa == 0. */
        if (n_grupa == 0) break;

            /* Slucajna permutacija grupe. */
        slucajno_poredaj(grupa, n_grupa);

            /* Ispis te grupe. */
        for (i = 0; i < n_grupa; ++i)
            ispis_trk(izlaz, ++start, &grupa[i]);
    }

        /* Zatvaranje datoteka. */
    fclose(ulaz);
    fclose(izlaz);

    return 0;
}
